package com.realnet.basicp1.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basicp1.Entity.Category;
import com.realnet.basicp1.Services.CategoryService ;


@RequestMapping(value = "/Category")
 @CrossOrigin("*") 
@RestController
public class CategoryController {
	@Autowired
	private CategoryService Service;

@Value("${projectPath}")
	private String projectPath;
 


	@PostMapping("/Category")
		  public Category Savedata(@RequestBody Category data) {
		Category save = Service.Savedata(data)	;

		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Category/{id}")
	public  Category update(@RequestBody Category data,@PathVariable Integer id ) {
		Category update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Category/getall/page")
	public Page<Category> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Category> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Category")
	public List<Category> getdetails() {
		 List<Category> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Category")
	public List<Category> getallwioutsec() {
		 List<Category> get = Service.getdetails();		
		return get;
}
@GetMapping("/Category/{id}")
	public  Category  getdetailsbyId(@PathVariable Integer id ) {
		Category  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Category/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}



}